/*	
 *	clipmisc.c
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Wed Dec 12 21:51:29 JST 2001 Naoyuki Sawa
 *	- 쐬JnB
 *	* Thu May 30 22:41:27 JST 2002 Naoyuki Sawa
 *	- die()̏I{^ASTARTSELECTɕύXB
 *	* Sun Jan 26 19:33:00 JST 2003 Naoyuki Sawa
 *	- die()֐̐錾__attribute__((noreturn))ǉ̂ŁA
 *	  x}̂߁Adie()֐̍Ōexit(1)ǉB
 *	  :__attribute__((...))͊֐錾̂ݎw\łB
 *	       ֐Ɏw肷ƃRpCG[ƂȂ܂B
 *	* Sun May 4 18:05:00 JST 2003 Naoyuki Sawa
 *	- fpk_size()/fpk_load()ǉ܂B
 *	  ȑOAzip`̃T|[gǉɁAfpk`̃T|[g͍폜̂łA
 *	  󂫃eʂNzipWJpobt@(32K)Ȃ悤ȏꍇ
 *	  ͂fpk`gƂ̂ŁAfpk`̃T|[gĎ܂B
 *	* Sat Nov 22 06:00:00 JST 2003 Naoyuki Sawa
 *	- g[Xo(TRACE_ON/TRACE/trace())ǉ܂B
 *	* Wed Sep 15 06:36:00 JST 2004 Naoyuki Sawa
 *	- RpCoÔ߁ARND8/16,RND8/16_RANGE}N֐܂B
 *	  ߋ̃\[X̌݊̂߁A֐Ăяo}N`Ă܂B
 */
#include "clip.h"

/*****************************************************************************
 *	ėp}NE֐
 *****************************************************************************/

int
rnd8(int* seed)
{
	/* 8rbg(wZ80}V`̏x) */
	*seed = *seed * 5 + 0x3711;
	return (*seed >> 8) & 0xff;
}

int
rnd16(int* seed)
{
	/* 16rbg(VisualC++ 6.0 \VC98\CRT\SRC\RAND.C Qlɂ܂) */
	*seed = *seed * 214013 + 2531011;
	return (*seed >> 16) & 0xffff;
}

int
rnd8_range(int* seed, int a, int b)
{
	return rnd8(seed) % (b - a) + a;
}

int
rnd16_range(int* seed, int a, int b)
{
	return rnd16(seed) % (b - a) + a;
}

/*****************************************************************************
 *	G[
 *****************************************************************************/

void
die(const char* fmt, ...)
{
#ifdef PIECE
	/* as33AZúA`V{externƌȂ̂ŁA
	 * Iextern錾͕Kv܂B(_def_vbuff̂)
	 */
	asm("
	xcall pceLCDDispStop		; pceLCDDispStop();
	xld.w %r12, _def_vbuff		; pceLCDSetBuffer(_def_vbuff);
	xcall pceLCDSetBuffer
	xcall pceLCDDispStart		; pceLCDDispStart();
	xld.w %r12, 0			; pceFontSetType(0);
	xcall pceFontSetType
	xld.w %r12, 3			; pceFontSetTxColor(3);
	xcall pceFontSetTxColor
	xld.w %r12, 0			; pceFontSetBkColor(0);
	xcall pceFontSetBkColor
	xld.w %r12, 0			; pceFontSetPos(0, 0);
	xld.w %r13, 0
	xcall pceFontSetPos
	xld.w %r4, die_L10		; pceFontPrintf(fmt, ...);
	xld.w [%sp], %r4
	xjp pceFontPrintf
die_L10:
	xcall pceLCDTrans		; pceLCDTrans();
die_L20:				; for(;;) {
	xcall yield			;	yield();
	xcall pcePadGet			;	if(pcePadGet() & TRG_SELECT) {
	xand %r10, %r10, 0x4000		;
	xjreq die_L30			;
	xld.w %r12, 1			;		pceAppReqExit(1);
	xcall pceAppReqExit		;
die_L30:				;	}
	xjp die_L20			; }
	");
#else /*PIECE*/
	va_list ap;
	va_start(ap, fmt);
	vfprintf(stderr, fmt, ap);
	va_end(ap);
	fprintf(stderr, "\n");
	abort();
#endif /*PIECE*/
	exit(1); /* __attribute__((noreturn))̌x} */
}

/*****************************************************************************
 *	g[Xo
 *****************************************************************************/

void
trace(const char* fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	vfprintf(stderr, fmt, ap);
	va_end(ap);
}

/*****************************************************************************
 *	[eBeBFt@CpbN`
 *****************************************************************************/

static int
fpk_find(FILE* fp, const char* name, FILE_INFO* fi)
{
	int retval, i;
	FILE_PAC_INFO pi;

	/* fpkǂ݂܂B */
	/* ĂяoɃt@Cʒu擪ł邱ƁB̊֐rewind()܂B */
	retval = fread(&pi, 1, sizeof pi, fp);
	if(retval != sizeof pi) DIE();
	if(pi.head != FILE_PAC_INFO_HEAD) DIE(); /* VOl` */

	/* t@C𑖍āc */
	for(i = 0; i < pi.famount; i++) {
		/* t@Cǂ݂܂B */
		retval = fread(fi, 1, sizeof *fi, fp);
		if(retval != sizeof *fi) DIE();

		/* H */
		if(strncasecmp(fi->fname, name, sizeof fi->fname) == 0) break;
	}

	return i < pi.famount; /* 1:/0:Ȃ */
}

int
fpk_size(const char* fname, const char* name)
{
	int retval;
	FILE* fp;
	FILE_INFO fi;

	/* fpkt@CJ܂B */
	fp = fopen(fname, "rb");
	if(fp == NULL) DIE();

	/* t@CT܂B */
	retval = fpk_find(fp, name, &fi);
	if(!retval) DIE();

	/* fpkt@C܂B */
	fclose(fp);

	return fi.size;
}

int
fpk_load(const char* fname, const char* name, void* buffer, int buflen)
{
	int retval;
	FILE* fp;
	FILE_INFO fi;

	/* fpkt@CJ܂B */
	fp = fopen(fname, "rb");
	if(fp == NULL) DIE();

	/* t@CT܂B */
	retval = fpk_find(fp, name, &fi);
	if(!retval) DIE();
	if(fi.size > buflen) DIE(); /* obt@s */

	/* t@Cǂݍ݂܂B */
	retval = fseek(fp, fi.offset, SEEK_SET);
	if(retval != 0) DIE();
	retval = fread(buffer, 1, fi.size, fp);
	if(retval != fi.size) DIE();

	/* fpkt@C܂B */
	fclose(fp);

	return fi.size; /* ǂݍ񂾃TCYԂ܂ */
}

/*****************************************************************************
 *	[eBeBFIt@CpbN`
 *****************************************************************************/

const void*
fpk_address(const void* fpk, const char* name, int* size)
{
	int i;
	unsigned char* base;
	FILE_PAC_INFO* pi;
	FILE_INFO* fi;

	base = (unsigned char*)fpk;

	/* VOl`܂B */
	pi = (FILE_PAC_INFO*)(base + 0);
	if(pi->head != FILE_PAC_INFO_HEAD) DIE();

	/* t@CGgT܂B */
	fi = (FILE_INFO*)(base + sizeof(FILE_PAC_INFO));
	for(i = 0; i < pi->famount; i++) {
		if(strncasecmp(fi->fname, name, sizeof fi->fname) == 0) break;
		fi++;
	}
	if(i == pi->famount) DIE();

	/* t@CTCYi[܂B */
	if(size) *size = fi->size;

	/* t@C̐擪AhXԂ܂B */
	return base + fi->offset;
}

